﻿using System;
using System.Windows.Forms;

namespace BBTasker
{
    public partial class BBTaskerAdvSetting : Form
    {
        public static string StartDate = "";
        public static string StopDate = "";

        public BBTaskerAdvSetting()
        {
            InitializeComponent();
        }

        private void cancelBtn_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /// <summary>
        /// Set scheduler dates
        /// </summary>
        private void SetDate()
        {
            StartDate = StartDateObj.Value.ToString(" MM/dd/yyyy");
            StopDate = StopDateObj.Value.ToString("MM/dd/yyyy");
        }

        /// <summary>
        /// validate selected dates
        /// </summary>
        private void CheckDate()
        {
            DateTime startdate = Convert.ToDateTime(StartDate);
            DateTime enddate = Convert.ToDateTime(StopDate);
            DateTime today = DateTime.Today;
            if ((startdate <= today) && (today <= enddate))
            {
                
            }
            else
            {
                StopDate = "";
                StartDate = "";
                MessageBox.Show("Schedule date invalid");
            }
        }

        /// <summary>
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void submitBtn_Click(object sender, EventArgs e)
        {
            SetDate();

            CheckDate();
        }
    }
}