﻿/*
*	FILE			: BBthermostatDataDecryption.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DESCRIPTION 	: This library file manage the decryption of the  thermostat data.
*/

using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace BBThermostatDataEncryptor
{
    public class BBThermostatDataDecryption
    {
        /// <summary>
        /// </summary>
        private static string pSensor = "";

        private static string SensorKey = BBThermostatDataEncypDecrypKey.sKey();
        private static string SensorIV = BBThermostatDataEncypDecrypKey.sIV();
        private static byte[] SensorIVByte = { };
        private static byte[] SensorKeyByte = { };
        private static byte[] inputByteArray;
        private static MemoryStream ms = null;
        private static CryptoStream cs = null;

        /// <summary>
        /// This method decrypt the saved thermostat data
        /// </summary>
        /// <param name="SensorData"></param>
        /// <returns></returns>
        public static string DecryptData(string SensorData)
        {
            SensorIVByte = Encoding.UTF8.GetBytes(SensorIV.Substring(0, 8));
            SensorKeyByte = Encoding.UTF8.GetBytes(SensorKey.Substring(0, 8));

            inputByteArray = new byte[SensorData.Replace(" ", "+").Length];
            inputByteArray = Convert.FromBase64String(SensorData.Replace(" ", "+"));
            using (DESCryptoServiceProvider des = new DESCryptoServiceProvider())
            {
                ms = new MemoryStream();
                cs = new CryptoStream(ms, des.CreateDecryptor(SensorKeyByte, SensorIVByte), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                Encoding encoding = Encoding.UTF8;
                pSensor = encoding.GetString(ms.ToArray());
            }

            return pSensor;
        }
    }
}