﻿using BBSensorsErrorLog;
using System.Windows.Forms;

namespace BBTasker
{
    public partial class BBAccessPad : Form
    {
        private string passwordPin = "";
        private string passwordCheck = "04152019";
        public static bool access = false;

        public BBAccessPad()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Keypad 01
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn01_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "1";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 02
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn02_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "2";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 03
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn03_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "3";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 04
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn04_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "4";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 05
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn05_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "5";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 06
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn06_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "6";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 07
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn07_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "7";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 08
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn08_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "8";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 09
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn09_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "9";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Keypad 0
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btn0_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length < 8)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin += "0";
                pswBox.Text = passwordPin;
            }
            if (passwordPin.Length == 8)
            {
                PasswrdChecker();
            }
        }

        /// <summary>
        /// Check access pin
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnEnter_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length > 0)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin = "";
                pswBox.Text = passwordPin;
            }
        }

        /// <summary>
        /// Clear access pin
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClear_Click(object sender, System.EventArgs e)
        {
            if (passwordPin.Length > 0)
            {
                LockStatus.Image = Properties.Resources.loading__2016_10_29_16_24_24_UTC_;
                passwordPin = passwordPin.Remove(passwordPin.Length - 1);
                pswBox.Text = passwordPin;
            }
        }

        /// <summary>
        /// </summary>
        private void PasswrdChecker()
        {
            if (passwordPin != passwordCheck)
            {
                LockStatus.Image = Properties.Resources.error;

                access = false;
                BBSensorErrorLog.SaveErrorData("Access Pad Incorrect Password ");
            }
            if (passwordPin == passwordCheck)
            {
                LockStatus.Image = Properties.Resources.pass;

                access = true;
                BBSensorErrorLog.SaveErrorData("Access Pad correct Password ");
                this.Close();
            }
        }
    }
}