﻿/*
*	FILE			: BBthermostatDefinition.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DESCRIPTION 	: This library file manage the data definition for thermostat.
*/

namespace BBThermostatDefinitions
{
    public class BBThermostatDefinition
    {
        /// <summary>
        /// The data class for the thermostat
        /// </summary>
        public float temp { get; set; }

        public int tmode { get; set; }
        public int fmode { get; set; }
        public float t_heat { get; set; }
        public float t_cool { get; set; }
        public int ttarget { get; set; }
        public int program_mode { get; set; }
        public int tstate { get; set; }
        public int fstate { get; set; }
        public float humidity { get; set; }
        public int hold { get; set; }
    }
}